from typing import NamedTuple
from more_itertools import peekable

class State:
    indent = 0
    envs = []
    display_math = False
    inline_math = False
    brackets = []
    # Text mode inside math
    text_mode = False
    in_section = False

class Node:
    type: str
    content: str = ""
    children: 'list[Node]' = []

    def __init__(type: str, content: str = "", children: 'list[Node]' = []):
        self.type = type
        self.content = content
        self.children = children

state = State()
latex = ""
stack = ""
stream = peekable("""
=== Cinématique

--- Particularités du repère cylindrique

-  u_r->  et  u_theta->  ne sont **pas** constants
-  u_r->. = theta u_theta->
-  u_theta->. = -theta u_r->

--- Vecteurs

	OM->   = r u_r-> + z u_z->
	OM->.  = r. u_r-> + r theta. u_theta-> + z. u_z->
	OM->.. = (r.. - r theta.^2)__(a_r) u_r-> + (2 r. theta. + r theta..)__(a_theta) u_theta-> + z.. u_z->
	a_theta = 1/2 d/dt (r^2 theta.)

--- Types de mouvements

- Uniforme:  		|| OM->. || = "const" <=> OM->. · OM->.. = 0
- Circulaire:  		r = "const"
- Rectiligne:  		"direction" OM->.. = "const"
- Uniforméement varié:  || OM->.. || = "const"

=== Dynamique

--- Forces

- Gravitationnelle:  -G mm' / r^2 u->
  - Sur Terre:  -m g->  avec  g-> = -G M_T / (R_T+h)^2 u->
- Tension: colinéaire au fil, partant de l'objet suspendu
- Frottements solides:  R-> = R_t->__"tangentielle" + R_n->__"normale"
  -  "glissement" <== R_t/R_n >= f__"coef. de frottement"
- Frottements fluides:  -lambda v->

--- Lois de Newton

1. Il existe un référentiel galiléen dans lequel  "(pseudo)-isolé" => "TRUV"
2.  sum F-> = m a->
3.  F_(A->B)-> = -F_(B->A)->

--- Pendule

	theta.. + g/l sin theta = 0

Avec  sin theta ≈ theta  et  omega_0 := √(g/l)

	(theta.. + omega_0^2 theta = 0)__"oscillateur harmonique"

=== Énergies

--- Travail

	W__(A->B)(F->) 	= integral_A^B F-> · d(OM)->
			= F-> · AB-> <== F->. = 0->

- Poids:  W__(A->B)(P->) = ±mg(z_B - z_A) "si  (Oz)  est vertical ascendant"
- Réaction normale:  W(R_n->) = 0->

--- Énergies

	E_c := 1/2 m v(M)^2
	E_m := E_c + "énergies potentielles"

- Pesanteur:  E_p_p = mgz + "const"
- Élastique:  E_p_e = 1/2 k (l(t) - l_0)^2 + "const"

--- Puissance

	c"P"(F->) := F-> · d(OM)->

--- Force conservative

3 conditions:

-  W(F->) !depends "chemin parcouru"
-  W(F->) = Delta E_p
-  "projection" F-> "selon" x = -dE_p/dx
// in fractions, dA considered atomic, thus no needs for spaces around "/" in dE_p/dx (with A nonspaced literal) 

--- Théorèmes

- Énergie cinétique:  	Delta E_c = W(F->)
- Énergie mécanique:  	Delta E_m = W(F_(nc)->)
- Puissance cinétique:  P(F->) = E_c.
- Puissance mécanique:  P(F_(nc)->) = E_m.

--- Stabilité d'un équilibre

	x_e "est une position d'équilibre" <==def==> dE_p/dx (x_e) = 0

	x_e "stable" 	<==def==> -(x - x_e) (d^2 / dx^2)_x_e > 0
			<=> E_p(x_e) = min E_p

	x_e "instable"  <==def==> not (x_e "stable")
			<=> E_p(x_e) = max E_p

=== Moment cinétique

--- Définitions


// NEW!
// @table detects if content is tsv
// by default, if first cell is empty, assumed that headers=row 1, col 1

@table
		En un point  O			En un axe  Delta  passant par  O
de  F->		M_O->(F->) := OM-> ^ F->	M_Delta(F->) := M_O(F->) · u_Delta->
de  M		L_O->(M) := OM-> ^ m v->	L_Delta(F->) := L_O(F->) · u_Delta->

// END

// NEW!
// if two empty lines or new ((sub)sub)section after @env, implicitly closes @env ??
// END

~~~ Cas de nullité


	M_Delta(F->) = 0 <== @cases("ou")
		F-> // Delta
		F-> &"passe par" Delta

// NEW!
// Inline environments: M_Delta(F->) = 0 <== F-> @cases("ou") // \\ "passe par" @end Delta
// END

~~~ Cas  F-> _|_ Delta

	F-> _|_ Delta ==> M_Delta(F->) = ±__"sens direct/indirect" d__"bras de levier" F

Avec

	d := "distance entre l'axe et la droite portant  F->"

--- Théorème du moment cinétique

En réf. Galiléen:

	L_O->.(M) 	= M_O->(F->)
	L_Delta.(M) 	= M_Delta.(F->)

- Grandeurs reliées: Force & vitesse

=== Champs électromagnétiques

--- Champ électrique  E->

~~~ Définition

	E-> := q/(4 pi epsilon_0 r^2) u_r->
		= U/d u_x->

~~~ Effet

Modifie la vitesse de la particule

Toujours dans le sens des potentiels décroissants

--- Champ magnétique  B->

~~~ Définition

	B-> := B u_z->

~~~ Effet

	omega_c := eB/m

Modifie la trajectoire de la particule, la trajectoire devient:

	"Cercle"("centre" = (0; v_0/omega_c); "rayon" = v_0/omega_c)

	"rayon". = 0 => "rayon" = mv/(|q|B)

--- Forces

~~~ de Coulomb

	(q_1 q_2)/(4 pi epsilon_0 r^2) u_r->


	@cases
		q_1 q_2 > 0 ==> "répulsive"
		q_1 q_2 < 0 ==> "attractive"

	
	c"P"("coulomb") = q E-> v->

~~~ de Lorentz

	q · (E-> + v-> ^ B->)

""")

while stream:
    char = next(stream)
    stack += char
    print(stack)
    if stack[:3] in ('===', '---', '~~~') and not state.indent:
        command = {
            '=': 'section',
            '-': 'subsection',
            '~': 'subsubsection'
        }[stack[0]]
        stack = stack.lstrip('-=~')
        stack = stack.strip()
        latex += "\%s{%s}" % (command, stack[0:stack.find('\n')])
        stack = stack.replace(stack[0:stack.find('\n')], '', count=1)
    
